/*----- PROTECTED REGION ID(KeithleyMultimetersClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id:  $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source:  $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        KeithleyMultimetersClass.cpp
//
// description : C++ source for the KeithleyMultimetersClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the KeithleyMultimeters once per process.
//
// project :     Keithley multimeters device
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


// #include "KeithleyMultimeters.h"
#include "KeithleyMultimetersClass.h"

/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass.cpp

//-------------------------------------------------------------------
/**
 *	Create KeithleyMultimetersClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_KeithleyMultimeters_class(const char *name) {
		return KeithleyMultimeters_ns::KeithleyMultimetersClass::init(name);
	}
}

namespace KeithleyMultimeters_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
KeithleyMultimetersClass *KeithleyMultimetersClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		KeithleyMultimetersClass::KeithleyMultimetersClass(string &s)
 * description : 	constructor for the KeithleyMultimetersClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
KeithleyMultimetersClass::KeithleyMultimetersClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering KeithleyMultimetersClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(KeithleyMultimetersClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass::constructor

	cout2 << "Leaving KeithleyMultimetersClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		KeithleyMultimetersClass::~KeithleyMultimetersClass()
 * description : 	destructor for the KeithleyMultimetersClass
 */
//--------------------------------------------------------
KeithleyMultimetersClass::~KeithleyMultimetersClass()
{
	/*----- PROTECTED REGION ID(KeithleyMultimetersClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		KeithleyMultimetersClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
KeithleyMultimetersClass *KeithleyMultimetersClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new KeithleyMultimetersClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		KeithleyMultimetersClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
KeithleyMultimetersClass *KeithleyMultimetersClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		ReadBufferedDataClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ReadBufferedDataClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ReadBufferedDataClass::execute(): arrived" << endl;
	((static_cast<KeithleyMultimeters *>(device))->read_buffered_data());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		WriteReadClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *WriteReadClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "WriteReadClass::execute(): arrived" << endl;
	Tango::DevString argin;
	extract(in_any, argin);
	return insert((static_cast<KeithleyMultimeters *>(device))->write_read(argin));
}

//--------------------------------------------------------
/**
 * method : 		AbortClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AbortClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AbortClass::execute(): arrived" << endl;
	((static_cast<KeithleyMultimeters *>(device))->abort());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ConfigureClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ConfigureClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ConfigureClass::execute(): arrived" << endl;
	((static_cast<KeithleyMultimeters *>(device))->configure());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StartAcquisitionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StartAcquisitionClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StartAcquisitionClass::execute(): arrived" << endl;
	((static_cast<KeithleyMultimeters *>(device))->start_acquisition());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimetersClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum KeithleyMultimetersClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimetersClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum KeithleyMultimetersClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimetersClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum KeithleyMultimetersClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimetersClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void KeithleyMultimetersClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "CommunicationLinkName";
	prop_desc = "Name of the device which handles the communication protocol";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SpecificConfiguration";
	prop_desc = "User Keithley configuration";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimetersClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void KeithleyMultimetersClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Device to interface a Keithley multimeters 2701. <br>");
	str_desc.push_back("The Keithley is configured in Voltmeter <br>");
	str_desc.push_back("The ReadBufferedData command initiate a scan and <br>");
	str_desc.push_back("readback data stored in the Keithley buffer up to 450000 points. <br>");
	str_desc.push_back("nbPoins and nPLC attributes are INVALID in RUNNING state (while Keithley integrates).");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("KeithleyMultimeters");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Tango::Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimetersClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void KeithleyMultimetersClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(KeithleyMultimetersClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new KeithleyMultimeters(this, (*devlist_ptr)[i]));							 
	}

	//	WARN : No erase cause of crash with yat dyn attrs(log, info)!!!!

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		KeithleyMultimeters *dev = static_cast<KeithleyMultimeters *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}
	return;
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new KeithleyMultimeters(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		KeithleyMultimeters *dev = static_cast<KeithleyMultimeters *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(KeithleyMultimetersClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimetersClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void KeithleyMultimetersClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(KeithleyMultimetersClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass::attribute_factory_before
	//	Attribute : nPLC
	nPLCAttrib	*nplc = new nPLCAttrib();
	Tango::UserDefaultAttrProp	nplc_prop;
	nplc_prop.set_description("Integration rate in line cycles in the range [0.002,50]");
	nplc_prop.set_label("nPLC");
	//	unit	not set for nPLC
	//	standard_unit	not set for nPLC
	//	display_unit	not set for nPLC
	nplc_prop.set_format("%4.2f");
	nplc_prop.set_max_value("50");
	nplc_prop.set_min_value("0.002");
	//	max_alarm	not set for nPLC
	//	min_alarm	not set for nPLC
	//	max_warning	not set for nPLC
	//	min_warning	not set for nPLC
	//	delta_t	not set for nPLC
	//	delta_val	not set for nPLC
	
	nplc->set_default_properties(nplc_prop);
	//	Not Polled
	nplc->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(nplc);

	//	Attribute : triggerSource
	triggerSourceAttrib	*triggersource = new triggerSourceAttrib();
	Tango::UserDefaultAttrProp	triggersource_prop;
	triggersource_prop.set_description("Select control source (IMMediate, TIMer, MANual, BUS or EXTernal).");
	triggersource_prop.set_label("triggerSource");
	//	unit	not set for triggerSource
	//	standard_unit	not set for triggerSource
	//	display_unit	not set for triggerSource
	triggersource_prop.set_format("%s");
	//	max_value	not set for triggerSource
	//	min_value	not set for triggerSource
	//	max_alarm	not set for triggerSource
	//	min_alarm	not set for triggerSource
	//	max_warning	not set for triggerSource
	//	min_warning	not set for triggerSource
	//	delta_t	not set for triggerSource
	//	delta_val	not set for triggerSource
	
	triggersource->set_default_properties(triggersource_prop);
	//	Not Polled
	triggersource->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(triggersource);

	//	Attribute : nbPoints
	nbPointsAttrib	*nbpoints = new nbPointsAttrib();
	Tango::UserDefaultAttrProp	nbpoints_prop;
	nbpoints_prop.set_description("Acquisition number of points");
	nbpoints_prop.set_label("nb points");
	//	unit	not set for nbPoints
	//	standard_unit	not set for nbPoints
	//	display_unit	not set for nbPoints
	nbpoints_prop.set_format("%d");
	//	max_value	not set for nbPoints
	//	min_value	not set for nbPoints
	//	max_alarm	not set for nbPoints
	//	min_alarm	not set for nbPoints
	//	max_warning	not set for nbPoints
	//	min_warning	not set for nbPoints
	//	delta_t	not set for nbPoints
	//	delta_val	not set for nbPoints
	
	nbpoints->set_default_properties(nbpoints_prop);
	//	Not Polled
	nbpoints->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(nbpoints);

	//	Attribute : nbBufferizedPoints
	nbBufferizedPointsAttrib	*nbbufferizedpoints = new nbBufferizedPointsAttrib();
	Tango::UserDefaultAttrProp	nbbufferizedpoints_prop;
	nbbufferizedpoints_prop.set_description("Number of points in the Keithley buffer");
	nbbufferizedpoints_prop.set_label("nb bufferized points");
	//	unit	not set for nbBufferizedPoints
	//	standard_unit	not set for nbBufferizedPoints
	//	display_unit	not set for nbBufferizedPoints
	nbbufferizedpoints_prop.set_format("%d");
	//	max_value	not set for nbBufferizedPoints
	//	min_value	not set for nbBufferizedPoints
	//	max_alarm	not set for nbBufferizedPoints
	//	min_alarm	not set for nbBufferizedPoints
	//	max_warning	not set for nbBufferizedPoints
	//	min_warning	not set for nbBufferizedPoints
	//	delta_t	not set for nbBufferizedPoints
	//	delta_val	not set for nbBufferizedPoints
	
	nbbufferizedpoints->set_default_properties(nbbufferizedpoints_prop);
	//	Not Polled
	nbbufferizedpoints->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(nbbufferizedpoints);

	//	Attribute : data
	dataAttrib	*data = new dataAttrib();
	Tango::UserDefaultAttrProp	data_prop;
	data_prop.set_description("Keithley bufferised data");
	data_prop.set_label("data");
	//	unit	not set for data
	//	standard_unit	not set for data
	//	display_unit	not set for data
	data_prop.set_format("%6.3f");
	//	max_value	not set for data
	//	min_value	not set for data
	//	max_alarm	not set for data
	//	min_alarm	not set for data
	//	max_warning	not set for data
	//	min_warning	not set for data
	//	delta_t	not set for data
	//	delta_val	not set for data
	
	data->set_default_properties(data_prop);
	//	Not Polled
	data->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(data);

	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(KeithleyMultimetersClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimetersClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void KeithleyMultimetersClass::command_factory()
{
	/*----- PROTECTED REGION ID(KeithleyMultimetersClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass::command_factory_before


	//	Command ReadBufferedData
	ReadBufferedDataClass	*pReadBufferedDataCmd =
		new ReadBufferedDataClass("ReadBufferedData",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pReadBufferedDataCmd);

	//	Command WriteRead
	WriteReadClass	*pWriteReadCmd =
		new WriteReadClass("WriteRead",
			Tango::DEV_STRING, Tango::DEV_STRING,
			"Low level command to send",
			"Command response (if any)",
			Tango::EXPERT);
	command_list.push_back(pWriteReadCmd);

	//	Command Abort
	AbortClass	*pAbortCmd =
		new AbortClass("Abort",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pAbortCmd);

	//	Command Configure
	ConfigureClass	*pConfigureCmd =
		new ConfigureClass("Configure",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pConfigureCmd);

	//	Command StartAcquisition
	StartAcquisitionClass	*pStartAcquisitionCmd =
		new StartAcquisitionClass("StartAcquisition",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"nio argout",
			Tango::OPERATOR);
	command_list.push_back(pStartAcquisitionCmd);

	/*----- PROTECTED REGION ID(KeithleyMultimetersClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		KeithleyMultimetersClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void KeithleyMultimetersClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(KeithleyMultimetersClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		KeithleyMultimetersClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void KeithleyMultimetersClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		KeithleyMultimeters *dev = static_cast<KeithleyMultimeters *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(KeithleyMultimetersClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimetersClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *KeithleyMultimetersClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; it++)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(KeithleyMultimetersClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	KeithleyMultimetersClass::Additional Methods
} //	namespace
